#ifndef DEFAULT_MIB_CFP
#define DEFAULT_MIB_CPP

/*
/*
 *
 * Radio API source module for PCnet-MOBILE 802.11 protocol firmware.
 *
 * Copyright (c) 1996, 1997, 1998 Advanced Micro Devices, Inc.
 * All rights reserved.
 *
 * Version 2.0
 *
 * Controller & Switch Development (CSD)
 *
 * Module Name: def_mib.cpp
 *
 * Globals Accessed:
 *
 * Callers:
 *
 * Called routines:
 *
 * Functional Description:
 *
 * Comments:
 * Default values for DS PHY.
 */

#include "mib.hpp"

const far char  Default_PHY_MIB[sizeof(PHY_MIB_Type)] = {

  0x14, 0x00,                         // aSlot_Time
  0x0a, 0x00,                         // aSIFS
  0x00, 0x09,                         // aMPDU_Maximum
  0xE0, 0x00,                         // aHop_Time
  0x01, 0x02, 0x82, 0x84,             // aSuprt_Data_Rates
  0x10,                               // aCurrent_Reg_Domain
  144,                                // aPreamble_Lngth
  48,                                 // aPLCP_Hdr_Lngth
  0x00, 0x0c, 0x00, 0x10,
  0x00, 0x20, 0x00, 0x40,             // Pwr_Up_Time[PWR_LVL_TABLE_SIZE];
  0x02,                               // IEEE_PHY_Type (DS)
  0x98, 0x88, 0x19, 0x9E, 0x99, 0x19, 0x0E, 0x77  //RCR STD 33A ID bytes

}; /* end Default_PHY_MIB */

const far char  Default_MAC_Mgmt_MIB[sizeof(MAC_Mgmt_MIB_Type)] = {

  0x00,                               // aPower_mgt_Mode = ACTIVE_MODE
  0x01,                               // aScan_Mode = ACTIVE_SCAN
  0x00,                               // aScan_State
  0x05,                               // aDTIM_Period
  0x00, 0x00,                         // aATIM_Window = 0
  0x00,                               // WEP_Required  0 = FALSE  04 = TRUE
  0x00,                               // Reserved
  0x64, 0x00,                         // aBeacon_Period
  0x64, 0x00,                         // aPassive_Scan_Duration
  0x00, 0x00,                         // aListen_Interval
  0xf4, 0x01,                         // aMedium_Occupancy_Limit
  0x37, 0x65,                         // aMax_MPDU_Time
  0x33, 0x00,                         // aCFP_Max_Duration
  0x05,                               // aCFP_Rate
  0x00,                               // do_Not_Receive_DTIMs = FALSE
  0x00, 0x00,                         // aStation_ID
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // aCurrent_BSS_ID
  0, 11,
  'I', 'E', 'E', 'E', ' ', '8',
  '0', '2', '.', '1', '1',            // aCurrent_ESS_ID

}; /* end Default_MAC_Mgmt_MIB */

const far char  Default_Stat_MAC_MIB[sizeof(Statistic_MAC_MIB_Type)] = {

  0x00, 0x00, 0x00, 0x00,             // aTransmitted_MPDU_Count;
  0x00, 0x00, 0x00, 0x00,             // aTransmitted_MSDU_Count;
  0x00, 0x00, 0x00, 0x00,             // aOctets_Transmitted_Count;
  0x00, 0x00,                         // aMulticast_Transmitted_Frame_Count;
  0x00, 0x00,                         // aBroadcast_Transmitted_Frame_Count;
  0x00, 0x00, 0x00, 0x00,             // aFailed_Count;
  0x00, 0x00, 0x00, 0x00,             // aRetry_Count;
  0x00, 0x00, 0x00, 0x00,             // aMultiple_Retry_Count;
  0x00, 0x00, 0x00, 0x00,             // aFrame_Duplicate_Count;
  0x00, 0x00, 0x00, 0x00,             // aRTS_Success_Count;
  0x00, 0x00, 0x00, 0x00,             // aRTS_Failure_Count;
  0x00, 0x00, 0x00, 0x00,             // aACK_Failure_Count;
  0x00, 0x00, 0x00, 0x00,             // aReceived_Frame_Count ;
  0x00, 0x00, 0x00, 0x00,             // aOctets_Received_Count;
  0x00, 0x00,                         // aMulticast_Received_Count;
  0x00, 0x00,                         // aBroadcast_Received_Count;
  0x00, 0x00, 0x00, 0x00,             // aFCS_Error_Count;
  0x00, 0x00, 0x00, 0x00,             // aError_Count;
  0x00, 0x00, 0x00, 0x00              // aWEP_Undecryptable_Count;

}; /* end Default_Stat_MAC_MIB */

const far char  Default_MAC_MIB[sizeof(MAC_MIB_Type)] = {

  0x00, 0x00, 0x00, 0x00,             // Reserved 1 and 2;
  0x01, 0x09,                         // aRTS_Threshold;
  0xff, 0x03,                         // aCW_max;
  0x1f, 0x00,                         // aCW_min;
  0x00,                               // aPromiscuous_Enable;
  0x00,                               // Reserved3;
  0x00, 0x00, 0x00, 0x00,             // Reserved4;
  0x0F,                               // aRTS_Retry_max;
  0x0F,                               // aData_Retry_max;
  0x00, 0x09,                         // aMax_Frame_Length;
  0x00, 0x09,                         // aFragmentation_Threshold;
  0x7A, 0x28,                         // aProbe_Delay (in btu units 5/4 usec)
  0x05, 0x00,                         // aMin_Probe_Response_Time;
  0x32, 0x00,                         // aMax_Probe_Response_Time;
  0x00, 0x80, 0x00, 0x00,             // aMax_Transmit_MSDU_Lifetime;
  0x00, 0x80, 0x00, 0x00,             // aMax_Receive_MSDU_Lifetime;
  0x0a, 0x00,                         // aStation_Basic_Rate;
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // aDesired_ESS_ID[ESS_ID_SIZE];
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00

}; /* end Default_MAC_MIB */

const far char  Default_MAC_Address_Status_MIB[sizeof(MAC_Address_Status_MIB_Type)] = {

  0x12, 0x34, 0x56, 0x78, 0x9a, 0xbc, // aMAC_Address
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // aGroup_Addresses
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00,                               // aTransmit_Enable_Status;
  0x00                                // Reserved;

}; /* end Default_MAC_Address_Status_MIB */

const far char  Default_Local_MIB[sizeof(Local_MIB_Type)] = {

  0x00,                               // Fragmentation_Dis;
  0x00,                               // Add_PLCP_Dis;
  0x00,                               // MAC_Hdr_Prsv;
  0x00,                               // Rx_Mgmt_Que_En;
  0x00,                               // Re_Assembly_Dis;
  0x00,                               // Strip_PLCP_Dis;
  0x00,                               // Rx_Error_Dis;
  0x00,                               // Power_Saving_Mode_Dis;
  0x00,                               // Accept_All_Multicast_Dis;
  0x00,                               // Check_Seq_Cntl_Dis;
  0x00,                               // Reserved;
  0x00,                               // Network_Mode;
  0x00,                               // PWD_Lvl;
  0x00,                               // CFP_Mode;
  0x00, 0x06, 0x00, 0x00,             // Tx_Buffer_Offset;
  0x00, 0x18, 0x00, 0x00,             // Tx_Buffer_Size;
  0x00, 0x1e, 0x00, 0x00,             // Rx_Buffer_Offset;
  0x00, 0x40, 0x00, 0x00,             // Rx_Buffer_Size;
  0x00,                               // NOT Acting As AP
  0x00,                               // Fill CFP;

}; /* end Default_Local_MIB */


#endif /* DEFAULT_MIB_CPP  */

