 ;
 ; Copyright (c) 1997 ADVANCED MICRO DEVICES, INC. Sunnyvale, California
 ;
 ; Module Name:
 ;    Assembly portion of Radio_API_Module
 ;
 ; Globals Accessed:
 ;
 ; Callers:
 ;
 ; Called routines:
 ;
 ; Functional Description:
 ;
 ; Comments:
 ;
 ; Diagnostics:
 ;
 ;
  .186
DGROUP  group  _DATA, _BSS
  assume  cs:RADIOAPI_TEXT, ds:DGROUP
_DATA  segment word public 'DATA'
d@  label  byte
d@w  label  word
_DATA  ends
_BSS  segment word public 'BSS'
b@  label  byte
b@w  label  word
_BSS  ends






RADIOAPI_TEXT  segment byte public 'CODE'
	;
	;  const Unsigned32 Radio_API_Module::get_PLCP_info(const Unsigned8* PLCP_ptr)
	;
  assume  cs:RADIOAPI_TEXT,ds:DGROUP

@Radio_API_Module@1get_PLCP_info$qpxuc  proc  far

    push    bp
    mov     bp,sp
    mov     bx,word ptr [bp+6]          ; bx - pointer to the plcp
    mov     cx,020h                     ; initialize the watchdog loop
    mov     byte ptr [si],0             ; initialize the save_RSSI_value

    mov     al,byte ptr [bx]            ; get the signal field from the plcp
    cmp     al,014h                     ; is the signal (rate) 2 Mb

    jne     short one_mbit_frame

    mov     byte ptr DGROUP:[DGROUP:_Next_Response_TX_Cntl],01Dh

length_timeout_loop2M:

    cmp     word ptr DGROUP:[DGROUP:_TIR]+12,5
    jae     short got_length2M          ; make sure the byte is in memory

    loop    short length_timeout_loop2M

    jmp     short length_timeout

got_length2M:

    mov     dx,word ptr [bx+2]

; The so-called 'length' is expressed in microseconds.  Since the rate field
; ..indicates that this frame is being received at 2Mbs (i.e., each byte
; ..takes 4 microseconds) we need to divide the value by 4 to convert the
; ..value into bytes.
;
; Note:  This time critical code therefore, the instruction shr reg,1 was
; ..choosen instead of shr reg,cnt since it requires 2 clock cycles for a
; ..reg,1 instruction and 5+cnt clock cycles for the reg,cnt instruction.

    shr     dx,1
    shr     dx,1

    jmp     short wait_for_crc16

one_mbit_frame:

    mov     al,00ah                     ; set the value to 1 Mb
    mov     byte ptr DGROUP:[DGROUP:_Next_Response_TX_Cntl],015h

length_timeout_loop1M:

    cmp     word ptr DGROUP:[DGROUP:_TIR]+12,5
    jae     short got_length1M          ; make sure the byte is in memory


    loop    short length_timeout_loop1M

length_timeout:

    mov     dx,-32768
    xor     ax,ax

    jmp     short done_get_PLCP_info

got_length1M:

    mov     dx,word ptr [bx+2]

; The so-called 'length' is expressed in microseconds.  Since the rate field
; ..indicates that this frame is being received at 1Mbs (i.e., each byte
; ..takes 8 microseconds) we need to divide the value by 8 to convert the
; ..value into bytes.
;
; Note:  This time critical code therefore, the instruction shr reg,1 was
; ..choosen instead of shr reg,cnt since it requires 2 clock cycles for a
; ..reg,1 instruction and 5+cnt clock cycles for the reg,cnt instruction.

    shr     dx,1
	 shr     dx,1
    shr     dx,1

wait_for_crc16:

    cmp     word ptr DGROUP:[DGROUP:_TIR]+12,8
    jb      short wait_for_crc16        ; the fc field has been rx'd

done_get_PLCP_info:

    pop  bp
    ret

@Radio_API_Module@1get_PLCP_info$qpxuc  endp

RADIOAPI_TEXT  ends






RADIOAPI_TEXT  segment byte public 'CODE'
;//* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	;
	;  const Unsigned8 Radio_API_Module::enable_response_if_good(const Unsigned16 good_length) const
	;
  assume  cs:RADIOAPI_TEXT,ds:DGROUP
@Radio_API_Module@1enable_response_if_good$xqxus  proc  far
  push  bp
  mov  bp,sp
  mov  bx,word ptr [bp+6]
   ;
   ;  /*
   ;   *  This routine is called from PHY_Rx for a received frame that needs a
   ;   *  response. In order to meet the SIFS time the transmitter is autostarted
   ;   *  at the response rate set in get_PLCP info. This routine will wait until
   ;   *  a correct length with the CRC good is received, or a length >= good_length
   ;   *  with a bad CRC is received or a timeout occurs.  Good CRC, Bad CRC or
	;   *  timeout status is  returned.
   ;   */
	;  {
   ;    /* Start transmitter for response TX even if already started */
   ;  #  ifdef COAX
   ;      TIR[TXMT_CONTROL] = TXS | CRC32 | TIR8_ENCRCTX;
   ;                        // Enable to start a transmission.
   ;                        // Do not use dynamic rate switch
   ;                        // for COAX builds
   ;  #  else
   ;  #    ifdef FORCE_QPSK
   ;        TIR[TXMT_CONTROL] = TXS | CRC32 | TIR8_ENCRCTX | TIR8_DR;
   ;                        // Enable to start a transmission.
	;                        // Uses dynamic rate switch
   ;  #    else
	;        TIR[TXMT_CONTROL] = Next_Response_TX_Cntl;
  mov  al,byte ptr DGROUP:[DGROUP:_Next_Response_TX_Cntl]
  mov  byte ptr DGROUP:[DGROUP:_TIR]+8,al
   ;
   ;                        // Enable to start a transmission.
   ;                        // Uses dynamic rate switch
   ;  #    endif
   ;  #  endif
   ;
   ;
   ;    int i = RX_DMA_TIMEOUT_VALUE;
  mov  cx,128
   ;
	;    register Boolean got_length = FALSE;
  mov  ah,0
   ;
   ;  Setup for out to stop RX DMA
  mov  dx,-54
  mov  al,68   ;
   ;
response_start_do:
   ;    do {
   ;      if (*((volatile Unsigned16* const)&(TIR[CRC32_CORRECT_LSB])) == good_length)
  cmp  word ptr DGROUP:[DGROUP:_TIR]+20,bx
  jne  short response_not_good_crc
   ;
	;      {
   ;        /* stop_rx_DMA() */
   ;        outportb(DMA_0_CONTROL, SRC_SYNC | LO_PRIORITY | TDRQ_DIS | CHANGE | DMA_STOP);
  out  dx,al
   ;
   ;
   ;        if ((TIR[TXMT_STATUS] & TXBSY) != 0) {
  test  byte ptr DGROUP:[DGROUP:_TIR]+9,1
  je  short response_bad_crc
   ;
   ;          /* transmitter started, return successfull */
	;          TIR[NETWORK_CONTROL] |= RXP;  // Hold the HSP3824 RX in reset
  or  byte ptr DGROUP:[DGROUP:_TIR],4
	;
   ;                          // SUTRO RX state machine still on
   ;                          // (TX in progress)
   ;          TIR[RCVR_CONTROL] = RXFR;    // Hold RX FIFO in reset
  mov  byte ptr DGROUP:[DGROUP:_TIR]+16,64
   ;
   ;                          // RX DMA will be started soon,
   ;                          // must have empty RX FIFO
   ;          return(GOOD_CRC);
  mov  al,0
  pop  bp
  ret
   ;
	;        } else {
   ;          /* transmitter failed to start, treat as bad CRC */
   ;          TIR[TXMT_CONTROL] = TXRES;    // Reset (auto) Transmitter
   ;          TIR[TXMT_CONTROL] = 0;      // (RX frame never arrived)
   ;          return(BAD_CRC);
   ;        } /* end if */
   ;      } /* end if */
response_not_good_crc:
   ;
   ;      if ((*((volatile Unsigned16* const)&TIR[BYTE_COUNT_LSB]) >= good_length) ||
   ;        (*((volatile Unsigned16* const)&TIR[BYTE_COUNT_LSB]) == 0))
  cmp  word ptr DGROUP:[DGROUP:_TIR]+12,bx
  jae  short response_check_flag
  cmp  word ptr DGROUP:[DGROUP:_TIR]+12,0
  jne  short response_clear_flag
   ;
   ;      {
response_check_flag:
   ;        if (got_length != FALSE) {
  or  ah,ah
  je  short response_set_flag
   ;
   ;          /* stop_rx_DMA() */
   ;          outportb(DMA_0_CONTROL, SRC_SYNC | LO_PRIORITY | TDRQ_DIS | CHANGE | DMA_STOP);
  out  dx,al
   ;
	;
response_bad_crc:
   ;          /* got byte count == 0 or >= good_length more than once */
   ;          // Expected CRC32 failed
   ;          TIR[TXMT_CONTROL] = TXRES;    // Reset (auto) Transmitter
  mov  byte ptr DGROUP:[DGROUP:_TIR]+8,128
   ;
   ;          TIR[TXMT_CONTROL] = 0;      // (RX frame never arrived)
  mov  byte ptr DGROUP:[DGROUP:_TIR]+8,0
   ;
   ;          return(BAD_CRC);
  mov  al,1
  pop  bp
  ret
   ;
   ;        } else {
response_set_flag:
   ;          /* got byte count == 0 or >= good_length once */
   ;          got_length = TRUE;
  mov  ah,1
  jmp  short response_count
   ;
   ;        } /* end if */
   ;      } else {
response_clear_flag:
   ;        got_length = FALSE;
  mov  ah,0
   ;
   ;      } /* end if */
response_count:
   ;    } while (--i > 0); /* end do */
  dec  cx
  jg  short response_start_do
   ;
   ;
   ;    /* stop_rx_DMA() */
   ;    outportb(DMA_0_CONTROL, SRC_SYNC | LO_PRIORITY | TDRQ_DIS | CHANGE | DMA_STOP);
  out  dx,al
   ;
	;
   ;    /* wait loop timed out */
   ;    TIR[TXMT_CONTROL] = TXRES;          // Reset (auto) Transmitter
  mov  byte ptr DGROUP:[DGROUP:_TIR]+8,128
   ;
   ;    TIR[TXMT_CONTROL] = 0;            // (RX frame never arrived)
  mov  byte ptr DGROUP:[DGROUP:_TIR]+8,0
   ;
   ;    return(RX_DMA_TIMEOUT);
  mov  al,2
   ;
	;  } /* end enable_response_if_good */
  pop  bp
  ret
@Radio_API_Module@1enable_response_if_good$xqxus  endp
   ;
   ;
   ;
   ;
   ;
   ;
   ;  const Unsigned8 Radio_API_Module::enable_tx_if_good(const Unsigned16 good_length) const
   ;
  assume  cs:RADIOAPI_TEXT,ds:DGROUP
@Radio_API_Module@1enable_tx_if_good$xqxus  proc  far
  push  bp
  mov  bp,sp
  mov  bx,word ptr [bp+6]
   ;
   ;  /*
   ;   *  This routine is called from PHY_Rx for a received frame that needs a
   ;   *  next frame to be sent. In order to meet the SIFS time the transmitter
   ;   *  is autostarted at the rate previously set in the set_PHY_rate call.
   ;   *  This routine will wait until a correct length with the CRC good is
   ;   *  received, or a length > good_length with a bad CRC is received or a
   ;   *  timeout occurs.  Good CRC, Bad CRC or timeout status is  returned.
   ;   */
	;  {
   ;    /* Start transmitter for TX even if already started */
	;  #  ifdef COAX
   ;      TIR[TXMT_CONTROL] = TXS | CRC32 | TIR8_ENCRCTX;
   ;                        // Enable to start a transmission.
   ;                        // Do not use dynamic rate switch
   ;                        // for COAX builds
   ;  #  else
   ;  #    ifdef FORCE_QPSK
   ;        TIR[TXMT_CONTROL] = TXS | CRC32 | TIR8_ENCRCTX | TIR8_DR;
   ;                        // Enable to start a transmission.
   ;                        // Uses dynamic rate switch
   ;  #    else
	;        TIR[TXMT_CONTROL] = Next_TX_Cntl;
  mov  al,byte ptr DGROUP:[DGROUP:_Next_TX_Cntl]
  mov  byte ptr DGROUP:[DGROUP:_TIR]+8,al
   ;
   ;                        // Enable to start a transmission.
   ;                        // Uses dynamic rate switch
   ;  #    endif
   ;  #  endif
   ;
   ;
   ;    int i = RX_DMA_TIMEOUT_VALUE;
  mov  cx,128
   ;
	;    register Boolean got_length = FALSE;
  mov  ah,0
	;
   ;  Setup for out to stop RX DMA
  mov  dx,-54
  mov  al,68   ;
   ;
tx_start_do:
   ;    do {
   ;      if (*((volatile Unsigned16* const)&(TIR[CRC32_CORRECT_LSB])) == good_length)
  cmp  word ptr DGROUP:[DGROUP:_TIR]+20,bx
  jne  short tx_not_good_crc
   ;
	;      {
   ;        /* stop_rx_DMA() */
	;        outportb(DMA_0_CONTROL, SRC_SYNC | LO_PRIORITY | TDRQ_DIS | CHANGE | DMA_STOP);
  out  dx,al
   ;
   ;
   ;        if ((TIR[TXMT_STATUS] & TXBSY) != 0) {
  test  byte ptr DGROUP:[DGROUP:_TIR]+9,1
  je  short tx_bad_crc
   ;
   ;          /* transmitter started, return successfull */
   ;          TIR[NETWORK_CONTROL] |= RXP;  // Hold the HSP3824 RX in reset
  or  byte ptr DGROUP:[DGROUP:_TIR],4
	;
   ;                          // SUTRO RX state machine still on
	;                          // (TX in progress)
   ;          TIR[RCVR_CONTROL] = RXFR;    // Hold RX FIFO in reset
  mov  byte ptr DGROUP:[DGROUP:_TIR]+16,64
   ;
   ;                          // RX DMA will be started soon,
   ;                          // must have empty RX FIFO
   ;          return(GOOD_CRC);
  mov  al,0
  pop  bp
  ret
   ;
	;        } else {
   ;          /* transmitter failed to start, treat as bad CRC */
	;          TIR[TXMT_CONTROL] = TXRES;    // Reset (auto) Transmitter
   ;          TIR[TXMT_CONTROL] = 0;      // (RX frame never arrived)
   ;          return(BAD_CRC);
   ;        } /* end if */
   ;      } /* end if */
tx_not_good_crc:
   ;
   ;      if ((*((volatile Unsigned16* const)&TIR[BYTE_COUNT_LSB]) >= good_length) ||
   ;        (*((volatile Unsigned16* const)&TIR[BYTE_COUNT_LSB]) == 0))
  cmp  word ptr DGROUP:[DGROUP:_TIR]+12,bx
  jae  short tx_check_flag
  cmp  word ptr DGROUP:[DGROUP:_TIR]+12,0
  jne  short tx_clear_flag
	;
   ;      {
tx_check_flag:
   ;        if (got_length != FALSE) {
  or  ah,ah
  je  short tx_set_flag
   ;
   ;          /* stop_rx_DMA() */
   ;          outportb(DMA_0_CONTROL, SRC_SYNC | LO_PRIORITY | TDRQ_DIS | CHANGE | DMA_STOP);
  out  dx,al
   ;
	;
tx_bad_crc:
	;          /* got byte count == 0 or >= good_length more than once */
   ;          // Expected CRC32 failed
   ;          TIR[TXMT_CONTROL] = TXRES;    // Reset (auto) Transmitter
  mov  byte ptr DGROUP:[DGROUP:_TIR]+8,128
   ;
   ;          TIR[TXMT_CONTROL] = 0;      // (RX frame never arrived)
  mov  byte ptr DGROUP:[DGROUP:_TIR]+8,0
   ;
   ;          return(BAD_CRC);
  mov  al,1
  pop  bp
  ret
   ;
	;        } else {
tx_set_flag:
   ;          /* got byte count == 0 or >= good_length once */
   ;          got_length = TRUE;
  mov  ah,1
  jmp  short tx_count
   ;
   ;        } /* end if */
   ;      } else {
tx_clear_flag:
   ;        got_length = FALSE;
  mov  ah,0
   ;
	;      } /* end if */
tx_count:
   ;    } while (--i > 0); /* end do */
  dec  cx
  jg  short tx_start_do
   ;
   ;
   ;    /* stop_rx_DMA() */
   ;    outportb(DMA_0_CONTROL, SRC_SYNC | LO_PRIORITY | TDRQ_DIS | CHANGE | DMA_STOP);
  out  dx,al
   ;
	;
   ;    /* wait loop timed out */
	;    TIR[TXMT_CONTROL] = TXRES;          // Reset (auto) Transmitter
  mov  byte ptr DGROUP:[DGROUP:_TIR]+8,128
   ;
   ;    TIR[TXMT_CONTROL] = 0;            // (RX frame never arrived)
  mov  byte ptr DGROUP:[DGROUP:_TIR]+8,0
   ;
   ;    return(RX_DMA_TIMEOUT);
  mov  al,2
   ;
   ;  } /* end enable_tx_if_good */
  pop  bp
  ret
@Radio_API_Module@1enable_tx_if_good$xqxus  endp
;//* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
RADIOAPI_TEXT  ends





RADIOAPI_TEXT  segment byte public 'CODE'
;* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; void Radio_API_Module::save_RSSI() {
;
; This routine conditionally reads the RSSI value from register cr10 address
; 028h of the Harris 3824 or the signal quality value from register cr38
; address 098h and stores the value in class Radio_API_Module variable
; Unsigned8 saved_RSSI_value.
;
; The 3824 register is read using TIR2 Serial Device and TIR3 Fast Serial
; Port Write registers.  The TIR Register configuration for the 3824 is as
; follows:
;
; 7 - Reserved
; 6 - SDSEL3    Write/Read
; 5 - SDSEL2    Data/Address
; 4 - SDSEL1    Chip Select Enable/Disable
; 3 - SDCP      Serial Device Clock Auto Pulse
; 2 - SDC       Serial Device Clock
; 1 - SDDT      Serial Device Data Tristate
; 0 - SDD       Serial Device Data
;
; Lastly, the Borland C++ compiler uses si as the 'THIS' pointer of a class
; structure.  In this case saved_RSSI_value is at the beginning of the class
; therefore one will notice at the end of this routine the read value is
; moved to the location which is pointed to by si.

    assume  cs:RADIOAPI_TEXT,ds:DGROUP
@Radio_API_Module@1save_RSSI$qv  proc  far

; ah is used to accumulate the serial value
; al is used to read the value from the pin
; si is used as an index to the serial device register

    push    ax
    push    si
    mov     si,offset _TIR+2
    xor     ax,ax

; assert write, address phase, chip select disabled, assert clock
    mov     byte ptr [si],048h  ; 0 100 1000b

; assert write, address phase, chip select disabled, negate clock
	 mov     byte ptr [si],040h  ; 0 100 0000b

; 7 bits of address are sent but only the 6 ms bits of the address used
; assert write, address phase, chip select enabled
; SDCLK inactive, SDC driven onto SDCLK, SDDATA is driven with SDD
    mov     byte ptr [si],050h  ; 0 101 0000b

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; The following definition is used in the conditional assembly to follow.
; If the value for the definition is non-zero then the RSSI register
; will be read at the time when this routine is called otherwise it will
; read the signal quality register.

kRSSIReg    equ     001h

; fast serial port write
IF  kRSSIReg
; write 5 bits of address to the device (11001b) msb 1st (addr 28h 00101000)
    mov     byte ptr DGROUP:[DGROUP:_TIR]+3,0b4h ; 101 10100b
ELSE
; write 5 bits of address to the device (11001b) msb 1st (addr 98h 10011000)
    mov     byte ptr DGROUP:[DGROUP:_TIR]+3,0b9h ; 101 11001b
ENDIF
; write 2 bits of address to the device (00b) msb first (reg 98h or 28)
    mov     byte ptr DGROUP:[DGROUP:_TIR]+3,040h ; 010 00000b

;****************************************************************************
; NOTE:  The access to the fast serial port should not be made using an
; index register as is the case with the Serial Device register.  The reason
; is that writing to this register back to back as in this code will
; overwrite the data which is being shifted out.
;****************************************************************************

; assert read, address phase, chip select enabled, tristate SDDATA
    mov     byte ptr [si],012h  ; 0 001 0010b

; assert read, address phase, chip select enabled, SDCLK active, tristate SDDATA
    mov     byte ptr [si],01ah  ; 0 001 1010b

; bit 7
; assert read, data phase, chip select enabled, SDCLK inactive, tristate SDDATA
    mov     byte ptr [si],032h  ; 0 011 0010b
    mov     al,byte ptr [si]    ; read the SDDATA pin
    shr     al,1                ; move SDD into the carry flag
    rcl     ah,1                ; move carry flag into ah

; bit 6
; from this point forward the every time the TIR2 register is written it
; will activate the SDCLK pin thus clocking in the data
; assert read, data phase, chip select, SDCLK active, trisate SDDATA
    mov     byte ptr [si],03ah  ; 0 011 1010b
	 mov     al,byte ptr [si]    ; read the SDDATA pin
    shr     al,1                ; move SDD into the carry flag
	 rcl     ah,1                ; move carry flag into ah

; bit 5
    mov     byte ptr [si],03ah  ; 0 011 1010b
    mov     al,byte ptr [si]
    shr     al,1
    rcl     ah,1

; bit 4
    mov     byte ptr [si],03ah  ; 0 011 1010b
    mov     al,byte ptr [si]
	 shr     al,1
    rcl     ah,1

; bit 3
    mov     byte ptr [si],03ah  ; 0 011 1010b
    mov     al,byte ptr [si]
    shr     al,1
    rcl     ah,1

; bit 2
    mov     byte ptr [si],03ah  ; 0 011 1010b
    mov     al,byte ptr [si]
    shr     al,1
	 rcl     ah,1

; bit 1
    mov     byte ptr [si],03ah  ; 0 011 1010b
    mov     al,byte ptr [si]
    shr     al,1
    rcl     ah,1

; bit 0
    mov     byte ptr [si],03ah  ; 0 011 1010b
    mov     al,byte ptr [si]
    shr     al,1
    rcl     ah,1

; assert read, data phase, chip select enabled, SDCLK active, tristate SDDATA
	 mov     byte ptr [si],03ah  ; 0 011 1010b

; assert write, address phase, chip select disabled, SDCLK inactive, tristate SDDATA
    mov     byte ptr [si],040h  ; 0 100 0000b

IF  kRSSIReg
    and     ah,03fh             ; bit 7 and 6 are junk for the RSSI register
ELSE
ENDIF
    pop     si
    mov     [si],ah
	 pop     ax

	 ret

@Radio_API_Module@1save_RSSI$qv  endp
RADIOAPI_TEXT  ends



  extrn  _TIR:byte
  extrn  _Next_TX_Cntl:byte
  extrn  _Next_Response_TX_Cntl:byte

  public  @Radio_API_Module@1get_PLCP_info$qpxuc
  public  @Radio_API_Module@1enable_tx_if_good$xqxus
  public  @Radio_API_Module@1enable_response_if_good$xqxus
  public  @Radio_API_Module@1save_RSSI$qv

  end
